=== debian/changelog ===
cc65 (2.17-1) unstable; urgency=medium

  * New upstream release.
  * Update debhelper level to 11:
    - don't specify parallel to debhelper.
  * Update Standards-Version to 4.1.3 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 10 Mar 2018 18:02:01 +0000
