=== debian/control ===
Source: cc65
Section: otherosfs
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper (>= 11), linuxdoc-tools
Standards-Version: 4.1.3
Homepage: https://cc65.github.io/cc65/

Package: cc65
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: cc65-doc
Description: complete cross development package for 65(C)02 systems
 cc65 is a complete cross development package for 65(C)02 systems, including
 a powerful macro assembler, a C compiler, linker, librarian and several
 other tools.
 .
 cc65 has C and runtime library support for many of the old 6502 machines,
 including
   - the following Commodore machines:
     - VIC20
     - C16/C116 and Plus/4
     - C64
     - C128
     - CBM 510 (aka P500)
     - the 600/700 family
     - newer PET machines (not 2001).
  - the Apple ][+ and successors.
  - the Atari 8 bit machines.
  - the Atari 5200 console.
  - GEOS for the C64, C128 and Apple //e.
  - the Nintendo Entertainment System (NES) console.
  - the Supervision console.
  - the Oric Atmos.
  - the Lynx console.
  - the Ohio Scientific Challenger 1P

Package: cc65-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: cc65 documentation
 cc65 is a complete cross development package for 65(C)02 systems, including
 a powerful macro assembler, a C compiler, linker, librarian and several
 other tools.
 .
 This package contains the documentation that is also available on
 the cc65 homepage.
