## cc65 2.18

=== libsrc/Makefile ===
--- 
+++ 
@@ -93,7 +93,7 @@
 
 define INSTALL_recipe
 
-$(if $(PREFIX),,$(error variable `PREFIX' must be set))
+$(if $(PREFIX),,$(error variable "PREFIX" must be set))
 $(INSTALL) -d $(DESTDIR)$(datadir)/$(dir)
 $(INSTALL) -m0644 ../$(dir)/*.* $(DESTDIR)$(datadir)/$(dir)
