=== debian/changelog ===
cc65 (2.18-1) unstable; urgency=medium

  * New upstream release.
  * Disable parallel building (closes: #883353).
  * Add watch file.
  * Update Standards-Version to 4.4.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 09 Nov 2019 20:23:26 +0000
