=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Build-Depends: debhelper (>= 11), linuxdoc-tools
-Standards-Version: 4.1.3
+Standards-Version: 4.4.1
 Homepage: https://cc65.github.io/cc65/
 
 Package: cc65
