=== doc/Makefile ===
--- 
+++ 
@@ -46,7 +46,7 @@
 	$(RM) -r ../html ../info
 
 install:
-	$(if $(PREFIX),,$(error variable `PREFIX' must be set))
+	$(if $(PREFIX),,$(error variable "PREFIX" must be set))
 ifeq ($(wildcard ../html),../html)
 	$(INSTALL) -d $(DESTDIR)$(htmldir)
 	$(INSTALL) -m0644 ../html/*.* $(DESTDIR)$(htmldir)
