=== libsrc/Makefile ===
--- 
+++ 
@@ -7,6 +7,7 @@
        c64    \
        cbm510 \
        cbm610 \
+       cx16   \
        pet    \
        plus4  \
        vic20
