=== debian/changelog ===
cc65 (2.19-1) unstable; urgency=medium

  * New upstream release.
  * Update debhelper level to 12 .
  * Update Standards-Version to 4.5.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 26 Nov 2020 22:46:00 +0100
