=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: otherosfs
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper (>= 11), linuxdoc-tools
-Standards-Version: 4.4.1
+Rules-Requires-Root: no
+Build-Depends: debhelper-compat (= 12), linuxdoc-tools
+Standards-Version: 4.5.1
 Homepage: https://cc65.github.io/cc65/
 
 Package: cc65
