=== debian/rules ===
--- 
+++ 
@@ -15,6 +15,6 @@
 	dh_auto_install -- PREFIX=/usr
 
 %:
-	dh $@
+	dh $@ --no-parallel
 
 .PHONY: override_dh_auto_build override_dh_auto_install
